"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const Draggable_1 = tslib_1.__importDefault(require("./Draggable"));
const Managed_1 = tslib_1.__importDefault(require("./Managed"));
function DraggableContainer({ onOrderChange, children }) {
    const [currentIdx, setCurrentIdx] = react_1.default.useState(null);
    const [toIdx, setToIdx] = react_1.default.useState(null);
    const onDragStart = (idx) => {
        setCurrentIdx(idx);
    };
    const onDragEnter = (idx) => {
        setToIdx(idx);
    };
    const onDragEnd = () => {
        const _currentIdx = currentIdx;
        const _toIdx = toIdx;
        if (currentIdx !== toIdx) {
            setCurrentIdx(null);
            setToIdx(null);
            onOrderChange(_currentIdx, _toIdx);
        }
    };
    return (react_1.default.createElement(react_1.default.Fragment, null, react_1.default.Children.map(children, (child, idx) => {
        return (react_1.default.createElement(Draggable_1.default, { key: idx, onDragStart: () => onDragStart(idx), onDragEnter: () => onDragEnter(idx), onDragEnd: () => onDragEnd() }, child));
    })));
}
DraggableContainer.Managed = Managed_1.default;
exports.default = DraggableContainer;
//# sourceMappingURL=DraggableContainer.js.map