import React from 'react';
import Draggable from './Draggable';
import { move } from './utils';
export default function ManagedDraggable({ list, setList, children }) {
    const [currentIdx, setCurrentIdx] = React.useState(null);
    const [toIdx, setToIdx] = React.useState(null);
    const onDragStart = (idx) => {
        setCurrentIdx(idx);
    };
    const onDragEnter = (idx) => {
        setToIdx(idx);
    };
    const onDragEnd = () => {
        const _currentIdx = currentIdx;
        const _toIdx = toIdx;
        if (currentIdx !== toIdx) {
            setCurrentIdx(null);
            setToIdx(null);
            setList(move(list, _currentIdx, _toIdx));
        }
    };
    return (React.createElement(React.Fragment, null, React.Children.map(children, (child, idx) => {
        return (React.createElement(Draggable, { key: idx, onDragStart: () => onDragStart(idx), onDragEnter: () => onDragEnter(idx), onDragEnd: () => onDragEnd() }, child));
    })));
}
//# sourceMappingURL=Managed.js.map